> This page is for API, version 2026-01-01 (Stable) (default).
> For other versions, use one of these documentation indexes:
> - 2026-01-01 (Stable) (default): https://developer.deel.com/api/stable/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.deel.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.deel.com/_mcp/server.

# Get case timeline

GET https://api.letsdeel.com/rest/immigration/cases/{case_id}/timeline

Retrieves the processes, steps and client or employee actions of a case, in order. Requires the case_id returned from the List cases endpoint.

 **Token scopes**: `immigration:read`

 **Beta**: this version requires the `X-Beta: true` request header and its contract may change before it is promoted to stable. It is scheduled to become stable on 2027-01-14.

Reference: https://developer.deel.com/api/reference/endpoints/immigration/get-case-timeline-v-2026-10-14

## Authentication

- `Authorization` header (bearer token, required) — ## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
- `Authorization` header (bearer token, required) — Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

## Servers

- `https://api.letsdeel.com/rest` (Production, default)
- `https://api-staging.letsdeel.com/rest` (Demo)

## Request

### Path parameters

- `case_id` (string, required) — The unique identifier of the case whose timeline should be returned.

### Headers

- `X-Beta` (enum, required, default: true) — Opts in to the beta version of this endpoint. Must be `true`.
  - Allowed values: `true`

## Response

### 200

Successful response with the case timeline.

- `data` (ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaData, required)

## Errors

### 400 Bad Request Error

Operation failed.

- `errors` (list of ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 401 Unauthorized Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 403 Forbidden Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 404 Not Found Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 500 Internal Server Error

Operation failed.

- `errors` (list of ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaErrorsItems, optional)

## Types

### ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaData

- `processes` (list of ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaDataProcessesItems, required) — Processes of the case in order.
- `ongoing_actions` (integer, required) — Number of actions currently waiting on the client or the employee.

### ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaErrorsItems

- `code` (string, optional) — The error code.
- `message` (string, optional) — Human-readable explanation of the error.

### ApiErrorRequest

- `method` (string, optional) — The HTTP method of the failed request
- `url` (string, optional) — The relative URL of the failed request
- `status` (double, optional) — The status code of the response
- `api_req_id` (string, optional) — The request ID of the failed request
- `docs` (string, optional) — A link to the official documentation for the requested endpoint resource
- `source` (string, optional) — The source handler which produced the returned error
- `code` (double, optional) — The code of the source handler which produced the returned error

### ApiError

- `message` (string, optional) — A description of the returned error
- `path` (string, optional) — The JSON path where input validation failed

### ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaDataProcessesItems

- `id` (string, required) — The unique identifier of the process.
- `name` (string, required) — Display name of the process.
- `state` (enum, required) — Whether the process is not started, active or completed.
  - Allowed values: `ACTIVE`, `COMPLETED`, `NOT_STARTED`
- `steps` (list of ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaDataProcessesItemsStepsItems, required) — Steps of the process in order.

### ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaDataProcessesItemsStepsItems

- `id` (string, required) — The unique identifier of the step.
- `name` (string, required) — Display name of the step.
- `state` (enum, required) — Whether the step is not started, active or completed.
  - Allowed values: `ACTIVE`, `COMPLETED`, `NOT_STARTED`
- `actions` (list of ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaDataProcessesItemsStepsItemsActionsItems, required) — Actions attached to the step, earliest due first.
- `activated_at` (string, required, nullable) — UTC timestamp when the step became active. Null while the step has not started.
- `completed_at` (string, required, nullable) — UTC timestamp when the step was completed. Null while the step is open.

### ImmigrationCasesCaseIdTimelineGetResponsesContentApplicationJsonSchemaDataProcessesItemsStepsItemsActionsItems

- `id` (string, required, nullable) — The unique identifier of the action.
- `name` (string, required, nullable) — Short title of the action.
- `type` (enum, required) — The kind of action expected from the assigned party.
  - Allowed values: `FILL_FORM`, `REVIEW_REOPENED_FORM`, `DOWNLOAD_BUSINESS_LETTER`, `AGENT_REVIEW_BUSINESS_LETTER`, `CLIENT_REVIEW_BUSINESS_LETTER`, `GENERATE_BUSINESS_VISA_LETTER`, `AGENT_REVIEW`, `CLIENT_REVIEW_DOCUMENT`, `AGENT_STATUS_UPDATE`, `QUOTE_CREATE`, `QUOTE_DRAFT`, `QUOTE_APPROVAL`, `QUOTE_PAYMENT_REQUEST`, `QUOTE_REJECTED`, `QUOTE_APPROVAL_EMPLOYEE`, `UPLOAD_DOCUMENT`, `UPLOAD_ADDITIONAL_DOCUMENT`, `FILL_ADDITIONAL_FORM`, `AGENT_ADD_SALESFORCE_URL`, `AGENT_STATUS_UPDATE_SLA_BREACH`, `FILL_REQUIRED_ROLES`, `REVIEW_SUBMITTED_FORM`, `REVIEW_FORM`, `REVIEW_UPLOADED_DOCUMENT`, `REVIEW_ZENDESK_COMMENT`, `SIGNATURE_PENDING`, `PETITION_AI_REVIEW`, `AMENDMENT_DETAIL_REVIEW`, `REVIEW_GOOGLE_DOCUMENT`, `PAY_INVOICE_ACTION`, `ESTIMATED_COMPLETION`, `REVIEW_VENDOR_ASSIGNMENT`, `UPDATE_VISA_TYPE`, `CUSTOM_TASK`, `AGENT_ADD_USCIS_RECEIPT_NUMBER`, `AGENT_ADD_SHIPPING_NUMBER`, `IDENTITY_VERIFICATION`, `IDENTITY_VERIFICATION_VERIFF`, `IDENTITY_VERIFICATION_REVIEW`, `SEND_VISA_APPLICATION_QUOTE`, `REVIEW_VISA_APPLICATION_QUOTE`, `COMPLIANCE_VERIFF`, `RTW_VERIFICATION_DOCUMENT_REVIEW`, `UPLOAD_REQUIRED_DOCUMENT`, `REVIEW_REQUIRED_DOCUMENT`, `ADD_BUSINESS_VISA_DETAILS`, `ADD_UK_SHARECODE`, `RUN_AI_AGENT`, `REVIEW_VISA_AUTOMATION_PAYLOAD`, `PRE_HIRE_DOCUMENT_REVIEW`, `ACKNOWLEDGE_CONTENT`, `PETITION_AUTONOMOUS_BUILD`, `PAY_MILESTONE_INVOICE`
- `status` (enum, required, nullable) — Progress of the action.
  - Allowed values: `TODO`, `ONGOING`, `COMPLETED`, `ARCHIVED`
- `due_date` (string, required, nullable) — UTC timestamp by which the action is expected to be completed.
- `user_type` (enum, required) — The party expected to complete the action: the client organization or the employee.
  - Allowed values: `CLIENT`, `APPLICANT`
- `description` (string, required) — What the assigned party has to do.
- `completed_at` (string, required, nullable) — UTC timestamp when the action was completed. Null while the action is open.

## Examples

**Response**

```json
{
  "data": {
    "processes": [
      {
        "id": "c7b8c9d0-e1f2-4b3c-8d4e-5f6a7b8c9d0a",
        "name": "Eligibility Check",
        "state": "ACTIVE",
        "steps": [
          {
            "id": "023ceb91-30ab-40d7-bd34-c7b9d96cfd14",
            "name": "In Review",
            "state": "ACTIVE",
            "actions": [
              {
                "id": "9b33c0a2-e85e-4977-b57f-4b2afd291eed",
                "name": "Upload additional documents",
                "type": "UPLOAD_ADDITIONAL_DOCUMENT",
                "status": "ONGOING",
                "due_date": "2026-10-14T12:42:31Z",
                "user_type": "CLIENT",
                "description": "Upload the additional supporting documents to proceed with your case.",
                "completed_at": "2026-10-15T09:10:00Z"
              }
            ],
            "activated_at": "2026-10-13T12:42:31Z",
            "completed_at": "2026-10-15T09:10:00Z"
          }
        ]
      }
    ],
    "ongoing_actions": 2
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.letsdeel.com/rest/immigration/cases/8e4a849f-10e0-4052-8b58-ca75d9fc0e88/timeline"

headers = {
    "X-Beta": "true",
    "Authorization": "Bearer <token>"
}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/immigration/cases/8e4a849f-10e0-4052-8b58-ca75d9fc0e88/timeline';
const options = {method: 'GET', headers: {'X-Beta': 'true', Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/immigration/cases/8e4a849f-10e0-4052-8b58-ca75d9fc0e88/timeline"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("X-Beta", "true")
	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/immigration/cases/8e4a849f-10e0-4052-8b58-ca75d9fc0e88/timeline")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["X-Beta"] = 'true'
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/immigration/cases/8e4a849f-10e0-4052-8b58-ca75d9fc0e88/timeline")
  .header("X-Beta", "true")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/immigration/cases/8e4a849f-10e0-4052-8b58-ca75d9fc0e88/timeline', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'X-Beta' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/immigration/cases/8e4a849f-10e0-4052-8b58-ca75d9fc0e88/timeline");
var request = new RestRequest(Method.GET);
request.AddHeader("X-Beta", "true");
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Beta": "true",
  "Authorization": "Bearer <token>"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/immigration/cases/8e4a849f-10e0-4052-8b58-ca75d9fc0e88/timeline")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```